from subprgs4Cat import *
import pystan

#
#       Yasuharu Okamoto, 2016.11
#

X, n, meanSt, sgmSt, fout, nm_fout = InputData()

N = n
St = []
Res = []
for v in X:
    St.append(v[0])
    Res.append(v[1])

print('\nSt = \n', St)
print('\nRes = \n', Res)

Data = {'N': N, 'St': St, 'Res': Res}

minSt = St[0]
maxSt = St[0]
for v in St:
    if minSt > v:
        minSt = v
    if maxSt < v:
        maxSt = v

def i_func():
    return dict(C = [(3.0 * minSt + 2.0 * maxSt) / 5.0,
                     (minSt + maxSt) / 2.0,
                     (2.0 * minSt + 3.0 * maxSt) / 5.0],
                    sigma = (maxSt - minSt) / 2.0)


fit = pystan.stan(file = 'pf4cat.stan', data = Data, init = i_func,
                   iter = 5000, warmup = 2000, pars = ['C', 'sigma'], n_jobs = 1)
                   

                       
print(fit)

mrg_sgm = fit['sigma']
mrg_C = fit['C']
mrg_C1 = []
mrg_Mu = []
mrg_C2 = []
for v in mrg_C:
    mrg_C1.append(v[0])
    mrg_Mu.append(v[1])
    mrg_C2.append(v[2])

mrg_sgm.sort()
mrg_C1.sort()
mrg_Mu.sort()
mrg_C2.sort()
NSimu = len(mrg_sgm)
n = N
    
DispResults( NSimu, X, n, mrg_C1, mrg_Mu, mrg_C2, mrg_sgm, fout )

fout.close()
print("\nOutput file {} was saved.".format(nm_fout))

