//      Yasuharu Okamoto, 2017.07

data {
    int N;
    real St[N];
    int<lower = 1, upper = 4> Res[N];
}

parameters {
        ordered[3] C;
        real<lower = 0.0> sigma;
}

transformed parameters {
    vector[4] p[N];

    for (i in 1:N){
        p[i][4] = Phi((St[i] - C[3]) / sigma);
        p[i][3] = Phi((St[i] - C[2]) / sigma) - Phi((St[i] - C[3]) / sigma);
        p[i][2] = Phi((St[i] - C[1]) / sigma) - Phi((St[i] - C[2]) / sigma);
        p[i][1] = 1.0 -Phi((St[i] - C[1]) / sigma);
    }
}

model {
    for (i in 1:N)
        Res[i] ~ categorical(p[i]);
}
